﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CollectionFilterSample
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private List<Person> liste = new List<Person>();

        public MainWindow()
        {
            FillListe();
            InitializeComponent();

            lstPersons.ItemsSource = liste;
            ListCollectionView view = CollectionViewSource.GetDefaultView(lstPersons.ItemsSource) as ListCollectionView;
            view.Filter = new Predicate<object>(FilterPersons);
        }

        public bool FilterPersons(object item)
        {
            Person pers = (Person)item;
            return (pers.Ort == "Essen");
        }

        private void FillListe()
        {
            liste.Add(new Person { Name = "Müller", Alter = 43, Ort = "Duisburg" });
            liste.Add(new Person { Name = "Meier", Alter = 43, Ort = "Bonn" });
            liste.Add(new Person { Name = "Schmidt", Alter = 43, Ort = "Essen" });
            liste.Add(new Person { Name = "Schulze", Alter = 43, Ort = "Köln" });
            liste.Add(new Person { Name = "Schneider", Alter = 43, Ort = "Essen" });
            liste.Add(new Person { Name = "mayer", Alter = 43, Ort = "Düsseldorf" });
        }
    }

    class Person
    {
        public string Name { get; set; }
        public int Alter { get; set; }
        public string Ort { get; set; }
    }
}

